/*header PHASERS*/
/*this unit contains code to calculate line coordinates from
angles lengths and starting points*/

#include <math.h>
#ifndef __GRAPHX_DEF_
 #include <graphics.h>
#endif
#ifndef __STDIO_H
 #include <stdio.h>
#endif
#define TRUE 1
#define FALSE 0
#define AND &&
#define OR ||

void phasersound(p)
short p;
{
 sound(500+(100*p));
 delay(50);
 sound(150+(100*p));
 delay(30);
 nosound();
}

float _mycos(d)
float d;
{
 return(cos(d*M_PI/180));
}

/*-------------------------------------------------------*/

float _mysin(d)
float d;
{
 return(sin(d*M_PI/180));
}

/*-------------------------------------------------------*/

void phaser(nd,noerase,P,ANGLE,leng,X,Y)
short nd,noerase,P;
float ANGLE,leng;
int X,Y;
{
 int x1,y1,x2,y2;
 int savcolor;
 x1=X;
 y1=Y;
 x2=X;
 y2=Y;
 x1=phasercoordx(ANGLE,leng,x1);
 y1=phasercoordy(ANGLE,leng,y1);
 savcolor=getcolor();
 setcolor(P);
 line(x2,y2,x1,y1);
 delay(50);
 if (noerase==FALSE)
 {
  setcolor(0);
  line(x2,y2,x1,y1);
 }
 setcolor(savcolor);
 if (nd==FALSE) phasersound(P);
}

int phasercoordy(ANGL,leng,_y)
unsigned ANGL,leng;
int _y;
{
 _y=_y+((_mysin(ANGL-90 % 360)*leng));
 return(_y);
}
int phasercoordx(ANGL,leng,_x)
unsigned ANGL,leng;
int _x;
{
 _x=_x+((_mycos(ANGL-90 % 360)*leng));
 return(_x);
}

void phaser2(p,angle,leng,_x,_y)
short p;
unsigned angle,leng;
float _x,_y;
{
 unsigned modangle[2];
 modangle[1]=angle-10;
 phaser(TRUE,TRUE,p,modangle[1],leng,_x,_y);
 modangle[2]=angle+10;
 phaser(TRUE,TRUE,p,modangle[2],leng,_x,_y);
 phaser(TRUE,FALSE,p,modangle[2],leng,_x,_y);
 phaser(TRUE,FALSE,p,modangle[1],leng,_x,_y);
 phasersound(p);
}
void phaser3(p,angle,leng,x,y)
short p;
unsigned angle,leng;
float x,y;
{
 unsigned modangle[2];
 modangle[1]=angle-15;
 phaser(TRUE,TRUE,p,modangle[1],leng,x,y);
 phaser(TRUE,TRUE,p,angle,leng,x,y);
 modangle[2]=angle+15;
 phaser(TRUE,TRUE,p,modangle[2],leng,x,y);
 phaser(TRUE,FALSE,p,modangle[2],leng,x,y);
 phaser(TRUE,FALSE,p,angle,leng,x,y);
 phaser(TRUE,FALSE,p,modangle[1],leng,x,y);
 phasersound(p);
}
void phaserc(q,p,angle,leng,x,y)
short q,p;
unsigned angle,leng;
float x,y;
{
 switch (q){
  case 1:{
	  phaser(FALSE,FALSE,p,angle,leng,x,y);
	  break;
	 }
  case 2:{
	  phaser2(p,angle,leng,x,y);
	  break;
	 }
  case 3:{
	  phaser3(p,angle,leng,x,y);
	  break;
	 }
 }
}

void deathburst(p,x,y)
short p;
float x,y;
{
 unsigned i;
 for (i=1;i==360;i++)
 {
  phaser(TRUE,TRUE,p,i,100,x,y);
 }
 phasersound(5);
 for (i=1;i==360;i++)
 {
  phaser(TRUE,FALSE,p,i,100,x,y);
 }
 phasersound(4);
}

short chkhitp(angle,leng,xx,yy,x,y)
unsigned angle,leng;
float xx,yy,x,y;
{
 int i,xxx,yyy;
 short hit;
 i=1;
 do {
  xxx=xx;
  yyy=yy;
  xxx=phasercoordx(angle,i,xxx);
  yyy=phasercoordy(angle,i,yyy);
  if ((((xxx<=x+5) && (xxx>=x-5)) && ((yyy<=y+8) && (yyy>=y-8)))==TRUE) hit=TRUE;
  i=i+1;
 }while((hit==TRUE) OR (i==leng));
 if (hit==TRUE) return(TRUE);
  else return(FALSE);
}
